#include <ctime>
#include <allegro.h>
#include <math.h>

int RESX = 200;
int RESY = 150;
int ARESX = 800;
int ARESY = 600;

int NUME = 100;
int displayFPS = 1;
int entitySpeedFactor = 200;
int entityAccelFactor = 400;

int automaticProgression = 1; //automatically progress entities
int lineSize = 5; //Size of entities
int entityBaseColor = 150; //Base starting color
int entityRandomColor = 100; //Random addition to base
int entityChainProbability = 20; //20 is default.
int entityType = 0; //0 is default
int entityMaxExplosion = 100;

int colorInc = 100; //Base increase of entity RGB. def. 100
int colorVar = 5; //Variation for increase of entity RGB

int blurRadius = 1; //Must be odd and > 0
int blurFade = 110; //100 = no fade, 200 = fade by a factor of 1/2
int blurProbability = 100; //100 = 100 percent chance

bool filterInverse = 0;
int antiAliasMode = 0;
int antiAliasGlow = 8;
int keydelay = 0;

int textcol = 0;

char topline[50];
char botline[50];

BITMAP *buffer;
BITMAP *temp;

class EntityClass
{
	public:
        int VOID; //is VOID
		double X; //X position
		double Y; //Y position
		double Xv; //X velocity
		double Yv; //Y velocity
		double Xa; //X acceleration
		double Ya; //Y acceleration
		int R; //Red value
		int G; //Green value
		int B; //Blue value
};

EntityClass Entity[10000];

FONT *bfont;

void AlterEntity(int Locator, int VOID, double X, double Y, double Xv, double Yv, double Xa, double Ya, int R, int G, int B);
void DrawEntity(int Locator);
void MotionBlur();
void AntiAlias();
void Explosion(int mainEntity);
void CheckKeystrokes();

void init();
void deinit();

int main() {
	init();
	bfont = load_font("bfont.pcx", NULL, NULL);
	
	int cycles = 0;
	int mouseR = rand()%127+127;
	int mouseG = rand()%127+127;
	int mouseB = rand()%127+127;
	int mouseRDIR = rand()%21-10;
	int mouseGDIR = rand()%21-10;
	int mouseBDIR = rand()%21-10;
	
	buffer = create_bitmap(RESX,RESY);
	temp = create_bitmap(RESX,RESY);
	clear(buffer);
	clear(temp);
	
	for (int i=0; i<10000; i++)
	{
		AlterEntity(i, 1,
		rand()%RESX, rand()%RESY,
		0, 0,
		0, 0,
		255, 255, 255);
	}
	
	int initTime = 0;
	int FPS = 0;

	while (!key[KEY_ESC])
	{
		poll_mouse();
		poll_keyboard();
		for (int i=0; i<NUME; i++)
  		{
			Entity[i].Xv += Entity[i].Xa;
			Entity[i].Yv += Entity[i].Ya;
			
			Entity[i].X += Entity[i].Xv;
			Entity[i].Y += Entity[i].Yv;

			Entity[i].R = (colorInc+rand()%colorVar)*Entity[i].R/100;
			Entity[i].G = (colorInc+rand()%colorVar)*Entity[i].G/100;
			Entity[i].B = (colorInc+rand()%colorVar)*Entity[i].B/100;
			
			if (Entity[i].R > 255) Entity[i].R = 255;
			if (Entity[i].G > 255) Entity[i].G = 255;
			if (Entity[i].B > 255) Entity[i].B = 255;
			
			if (Entity[i].X < 0) Entity[i].X = RESX;
			if (Entity[i].X > RESX) Entity[i].X = 0;
			if (Entity[i].Y < 0) Entity[i].Y = RESY;
			if (Entity[i].Y > RESY) Entity[i].Y = 0;
			
			int cutoff = 254;
            if (Entity[i].R > cutoff || Entity[i].G > cutoff || Entity[i].B > cutoff)
			{
				int randnum = rand()%100; //0-99
				if (randnum >= 0 && randnum < (99 - entityChainProbability)) {
					int rfact = entityRandomColor;
					int r = entityBaseColor + rand()%entityRandomColor;
					int g = entityBaseColor + rand()%entityRandomColor;
					int b = entityBaseColor + rand()%entityRandomColor;
					AlterEntity(i, 1, rand()%RESX, rand()%RESY, 0, 0, 0, 0, r, g, b);
				}
				else if (automaticProgression == 1)
				{
					Explosion(i);
				}
			}
		}
		
		if (mouse_b & 1)
		{
			for (int i=0; i<NUME-1; i++)
			{
				if (Entity[i].VOID == 1)
				{
					AlterEntity(i, 0, (RESX * mouse_x) / ARESX, (RESY * mouse_y) / ARESY, 0, 0, 0, 0,
					Entity[i].R,
					Entity[i].G,
					Entity[i].B);
					Explosion(i);
					i = NUME;
				}
			}
		}
		

		for (int i=0; i<NUME; i++) { if (Entity[i].VOID == 0) DrawEntity(i); }
		
		if (mouse_b & 2)
		{
			mouseR = mouseR + mouseRDIR;
			mouseG = mouseG + mouseGDIR;
			mouseB = mouseB + mouseBDIR;
			if (mouseR >= 255) { mouseRDIR = -1 * (rand()%20 + 10); mouseR = 255;}
			if (mouseG >= 255) { mouseGDIR = -1 * (rand()%20 + 10); mouseG = 255;}
			if (mouseB >= 255) { mouseBDIR = -1 * (rand()%20 + 10); mouseB = 255; }
			if (mouseR <= 92) { mouseRDIR = rand()%20 + 10; mouseR = 92; }
			if (mouseG <= 92) { mouseGDIR = rand()%20 + 10; mouseG = 92; }
			if (mouseB <= 92) { mouseBDIR = rand()%20 + 10; mouseB = 92; }
			for (int i=40; i>1; i--)
			{
				int tempR = 32 + mouseR - 5*i;
				int tempG = 32 + mouseG - 5*i;
				int tempB = 32 + mouseB - 5*i;
				if (tempR > 255) tempR = 255;
				if (tempG > 255) tempG = 255;
				if (tempB > 255) tempB = 255;
				if (tempR < 0) tempR = 0;
				if (tempG < 0) tempG = 0;
				if (tempB < 0) tempB = 0;
				circlefill(buffer, (RESX * mouse_x) / ARESX, (RESY * mouse_y) / ARESY, i/2, makecol(tempR, tempG, tempB));
				if (key[KEY_RCONTROL] || key[KEY_RSHIFT])
				{
					circlefill(buffer, RESX - (RESX * mouse_x) / ARESX, RESY - (RESY * mouse_y) / ARESY, i/2, makecol(tempR, tempG, tempB));
				}
				if (key[KEY_RSHIFT])
				{
                    circlefill(buffer, (RESX * mouse_x) / ARESX, RESY - (RESY * mouse_y) / ARESY, i/2, makecol(tempR, tempG, tempB));
                    circlefill(buffer, RESX - (RESX * mouse_x) / ARESX, (RESY * mouse_y) / ARESY, i/2, makecol(tempR, tempG, tempB));
				}
			}
		}
		if (blurProbability > 0) MotionBlur();
		CheckKeystrokes();

		acquire_screen();
		if (antiAliasMode == 0) stretch_blit(buffer, screen, 0, 0, RESX-1, RESY-1, 0, 0, ARESX, ARESY);
		else if (antiAliasMode >= 1)
		{
			AntiAlias();
			stretch_blit(temp, screen, 0, 0, RESX-1, RESY-1, 0, 0, ARESX, ARESY);
		}
		
		if (filterInverse == 0) textcol = makecol(255,255,255);
		else textcol = makecol(0,0,0);
		
		if (keydelay >= 1)
		{
			textprintf_ex(screen, bfont, 0, 20, textcol, -1, topline);
			textprintf_ex(screen, bfont, 0, 40, textcol, -1, botline);
			keydelay--;
		}
		
		if (displayFPS == 1)
		{
			int temp = clock() - initTime;
			if (cycles%2 == 0 && temp != 0) FPS = 2000 / temp;
			textprintf_ex(screen, bfont, 0, 0, textcol, -1, "%i FPS", FPS, mouseR, mouseG, mouseB);
			if (cycles%2 == 0)
			{
				initTime = clock();
			}
		}
		release_screen();
		
		if (key[KEY_ESC]) break;
		clear_keybuf();
        show_mouse(screen);
		cycles++;

	}
	free(buffer);
	free(temp);
	return 0;
}
END_OF_MAIN()

void CheckKeystrokes()
{
    if (keydelay < 7 || key[KEY_LCONTROL] || key[KEY_RCONTROL])
	{
		if (key[KEY_SPACE]) clear(buffer);
		
		else if (key[KEY_TILDE])
		{
			if (filterInverse == 0)
			{
				filterInverse = 1;
				uszprintf(topline, sizeof(topline), "Color inversion enabled when filtering is active.");
				uszprintf(botline, sizeof(botline), "");
				keydelay = 10;
			}
			else if (filterInverse == 1)
			 {
				filterInverse = 0;
				uszprintf(topline, sizeof(topline), "Color inversion disabled when filtering is active.");
				uszprintf(botline, sizeof(botline), "");
				keydelay = 10;
			}
		}

		else if (key[KEY_1])
		{
			uszprintf(topline, sizeof(topline), "Filtering disabled.");
			uszprintf(botline, sizeof(botline), " ");
			antiAliasMode = 0;
			keydelay = 10;
		}

		else if (key[KEY_2])
		{
			uszprintf(topline, sizeof(topline), "Filtering enabled.");
			uszprintf(botline, sizeof(botline), "Anti-aliasing mode");
			antiAliasMode = 1;
			keydelay = 10;
		}

		else if (key[KEY_3])
		{
			uszprintf(topline, sizeof(topline), "Filtering enabled.");
			uszprintf(botline, sizeof(botline), "Circular extrapolated anti-aliasing mode");
			antiAliasMode = 2;
			keydelay = 10;
		}

		else if (key[KEY_4])
		{
			uszprintf(topline, sizeof(topline), "Filtering enabled.");
			uszprintf(botline, sizeof(botline), "Circular reference mode");
			antiAliasMode = 3;
			keydelay = 10;
		}

		else if (key[KEY_5])
		{
			uszprintf(topline, sizeof(topline), "Filtering enabled.");
			uszprintf(botline, sizeof(botline), "Disco mode");
			antiAliasMode = 4;
			keydelay = 10;
		}

		else if (key[KEY_6])
		{
			uszprintf(topline, sizeof(topline), "Filtering enabled.");
			uszprintf(botline, sizeof(botline), "Disco mode II");
			antiAliasMode = 5;
			keydelay = 10;
		}

		else if (key[KEY_7])
		{
			uszprintf(topline, sizeof(topline), "Filtering enabled.");
			uszprintf(botline, sizeof(botline), "Water mode");
			antiAliasMode = 6;
			keydelay = 10;
		}

		else if (key[KEY_F1] && antiAliasGlow < 8)
		{
			antiAliasGlow++;
			uszprintf(topline, sizeof(topline), "Filter glow -1");
			uszprintf(botline, sizeof(botline), "Currently: %i",9 - antiAliasGlow);
			keydelay = 10;
		}

		else if (key[KEY_F2] && antiAliasGlow > 1)
		{
			antiAliasGlow--;
			uszprintf(topline, sizeof(topline), "Filter glow +1");
			uszprintf(botline, sizeof(botline), "Currently: %i",9 - antiAliasGlow);
			keydelay = 10;
		}

		else if (key[KEY_F5] && RESX > 20)
		{
			RESX -= 20;
			RESY -= 15;
            buffer = create_bitmap(RESX,RESY);
			temp = create_bitmap(RESX,RESY);
			uszprintf(topline, sizeof(topline), "Virtual Res -");
			uszprintf(botline, sizeof(botline), "%ix%i", RESX, RESY);
			keydelay = 10;
		}

		else if (key[KEY_F6] && RESX < 2400)
		{
			RESX += 20;
			RESY += 15;
            buffer = create_bitmap(RESX,RESY);
			temp = create_bitmap(RESX,RESY);
			uszprintf(topline, sizeof(topline), "Virtual Res +");
			uszprintf(botline, sizeof(botline), "%ix%i", RESX, RESY);
			keydelay = 10;
		}

		else if (key[KEY_Q])
		{
            blurRadius+=2;
            uszprintf(topline, sizeof(topline), "Fade radius +2");
            uszprintf(botline, sizeof(botline), "Currently: %i", blurRadius);
            keydelay = 10;
		}
		else if (key[KEY_A] && blurRadius >= 3)
		{
			blurRadius-=2;
			uszprintf(topline, sizeof(topline), "Fade radius -2");
			uszprintf(botline, sizeof(botline), "Currently: %i", blurRadius);
			keydelay = 10;
		}

		else if (key[KEY_W])
		{
			blurFade+=1;
			uszprintf(topline, sizeof(topline), "Fade color rate +1");
			uszprintf(botline, sizeof(botline), "Currently: %i", blurFade-100);
			keydelay = 10;
		}
		else if (key[KEY_S] && blurFade > 1)
		{
			blurFade-=1;
			uszprintf(topline, sizeof(topline), "Fade color rate -1");
			uszprintf(botline, sizeof(botline), "Currently: %i", blurFade-100);
			keydelay = 10;
		}

		else if (key[KEY_E] && blurProbability < 100)
		{
			blurProbability+=2;
			uszprintf(topline, sizeof(topline), "Fade probability +2");
			uszprintf(botline, sizeof(botline), "Currently: %i", blurProbability);
			keydelay = 10;
		}
		else if (key[KEY_D] && blurProbability > 0)
		{
			blurProbability-=2;
			uszprintf(topline, sizeof(topline), "Fade probability -2");
			uszprintf(botline, sizeof(botline), "Currently: %i", blurProbability);
			keydelay = 10;
		}

		else if (key[KEY_R] && NUME < 10000)
		{
			NUME+=10;
			uszprintf(topline, sizeof(topline), "Entities +10");
			uszprintf(botline, sizeof(botline), "Currently: %i", NUME);
			keydelay = 10;
		}
		else if (key[KEY_F] && NUME > 0)
		{
			NUME-=10;
			uszprintf(topline, sizeof(topline), "Entities -10");
			uszprintf(botline, sizeof(botline), "Currently: %i", NUME);
			keydelay = 10;
		}

		else if (key[KEY_T] && colorInc < 200)
		{
			colorInc+=1;
			uszprintf(topline, sizeof(topline), "Color inc. rate +1");
			uszprintf(botline, sizeof(botline), "Currently: %i", colorInc);
			keydelay = 10;
		}
		else if (key[KEY_G] && colorInc > 100)
		{
			colorInc-=1;
			uszprintf(topline, sizeof(topline), "Color inc. rate -1");
			uszprintf(botline, sizeof(botline), "Currently: %i", colorInc);
			keydelay = 10;
		}

		else if (key[KEY_Y] && colorVar < 200)
		{
			colorVar+=1;
			uszprintf(topline, sizeof(topline), "Color var inc rate +1");
			uszprintf(botline, sizeof(botline), "Currently: %i", colorVar);
			keydelay = 10;
		}
		else if (key[KEY_H] && colorVar > 1)
		{
			colorVar-=1;
			uszprintf(topline, sizeof(topline), "Color var. inc rate -1");
			uszprintf(botline, sizeof(botline), "Currently: %i", colorVar);
			keydelay = 10;
		}

		else if (key[KEY_U] && entitySpeedFactor < 10000)
		{
			entitySpeedFactor+=10;
			uszprintf(topline, sizeof(topline), "Entity speed divisor +10");
			uszprintf(botline, sizeof(botline), "Currently: %i", entitySpeedFactor);
			keydelay = 10;
		}
		else if (key[KEY_J] && entitySpeedFactor > 10)
		{
			entitySpeedFactor-=10;
			uszprintf(topline, sizeof(topline), "Entity speed divisor -10");
			uszprintf(botline, sizeof(botline), "Currently: %i", entitySpeedFactor);
			keydelay = 10;
		}

		else if (key[KEY_I] && entityAccelFactor < 10000)
		{
			entityAccelFactor+=10;
			uszprintf(topline, sizeof(topline), "Entity accel. divisor +10");
			uszprintf(botline, sizeof(botline), "Currently: %i", entityAccelFactor);
			keydelay = 10;
		}
		else if (key[KEY_K] && entityAccelFactor > 10)
		{
			entityAccelFactor-=10;
			uszprintf(topline, sizeof(topline), "Entity accel. divisor -10");
			uszprintf(botline, sizeof(botline), "Currently: %i", entityAccelFactor);
			keydelay = 10;
		}
		else if (key[KEY_O] && lineSize < 200)
		{
			lineSize+=1;
			uszprintf(topline, sizeof(topline), "Entity size +1");
			uszprintf(botline, sizeof(botline), "Currently: %i", lineSize);
			keydelay = 10;
		}
		else if (key[KEY_L] && lineSize > 1)
		{
			lineSize-=1;
			uszprintf(topline, sizeof(topline), "Entity size -1");
			uszprintf(botline, sizeof(botline), "Currently: %i", lineSize);
			keydelay = 10;
		}

		else if (key[KEY_Z])
		{
			if (automaticProgression == 0)
			{
				automaticProgression = 1;
				uszprintf(topline, sizeof(topline), "Automatic progression ON");
				uszprintf(botline, sizeof(botline), "");
				keydelay = 10;
			}
			else if (automaticProgression == 1)
			{
				automaticProgression = 0;
				uszprintf(topline, sizeof(topline), "Automatic progression OFF");
				uszprintf(botline, sizeof(botline), "");
				keydelay = 10;
			}
		}

		else if (key[KEY_Z])
		{
			if (automaticProgression == 0)
			{
				automaticProgression = 1;
				uszprintf(topline, sizeof(topline), "Automatic progression ON");
				uszprintf(botline, sizeof(botline), "");
				keydelay = 10;
			}
			else if (automaticProgression == 1)
			{
				automaticProgression = 0;
				uszprintf(topline, sizeof(topline), "Automatic progression OFF");
				uszprintf(botline, sizeof(botline), "");
				keydelay = 10;
			}
		}

		else if (key[KEY_X])
		{
			entityType = 0;
		    uszprintf(topline, sizeof(topline), "Entity shape 0");
		    uszprintf(botline, sizeof(botline), "Half square");
		    keydelay = 10;
		}

		else if (key[KEY_C])
		{
			entityType = 1;
		    uszprintf(topline, sizeof(topline), "Entity shape 1");
		    uszprintf(botline, sizeof(botline), "Solid circle");
		    keydelay = 10;
		}

		else if (key[KEY_V])
		{
			entityType = 2;
		    uszprintf(topline, sizeof(topline), "Entity shape 2");
		    uszprintf(botline, sizeof(botline), "Sphere");
		    keydelay = 10;
		}
		
		else if (key[KEY_B])
		{
			entityType = 3;
		    uszprintf(topline, sizeof(topline), "Entity shape 3");
		    uszprintf(botline, sizeof(botline), "Hollow square");
		    keydelay = 10;
		}
		
		else if (key[KEY_N])
		{
			entityType = 4;
		    uszprintf(topline, sizeof(topline), "Entity shape 4");
		    uszprintf(botline, sizeof(botline), "Filled square");
		    keydelay = 10;
		}
	}
}

void Explosion(int mainEntity)
{
	double xv, yv, xa, ya;
	int ents = 0;
	for (int j=0; j<NUME; j++)
	{
		if (Entity[j].VOID == 1 && rand()%(2+NUME/50) == 0)
		{
			xv = (double)(rand()%501-250);
			yv = (double)(rand()%501-250);
			xa = (double)(rand()%51-25);
			ya = (double)(rand()%51-25);
			AlterEntity(j, 0,
			Entity[mainEntity].X+rand()%3-1, Entity[mainEntity].Y+rand()%3-1,
			xv/entitySpeedFactor, yv/entitySpeedFactor,
			xa/entityAccelFactor, ya/entityAccelFactor,
			Entity[mainEntity].R-80-rand()%20, Entity[mainEntity].G-80-rand()%20, Entity[mainEntity].B-80-rand()%20);
			ents++;
		}
		if (ents >= entityMaxExplosion) j = NUME;
	}
}

void MotionBlur()
{
	int dir = 0;
	if (rand()%2 == 0) dir = 1;
	
	for (int h=0; h<RESX; h++)
	{
		int i = h;
		if (dir == 1) i = RESX-h-1;
		for (int j=0; j<RESY; j++)
		{
			if (rand()%100 < blurProbability)
			{
				int cval = getpixel(buffer, i, j);
				if (cval != makecol(0,0,0))
				{
					int r = getr(cval);
					int g = getg(cval);
					int b = getb(cval);

					r = (100*r)/blurFade;
					g = (100*g)/blurFade;
					b = (100*b)/blurFade;

					if (blurRadius >= 3) {
						int blurSub = blurRadius / 2;

	  					int imod = rand()%blurRadius - blurSub;
						if (i+imod < 0) { imod = 0; }
						if (i+imod > RESX-1) { imod = 0; }
						int jmod = rand()%blurRadius - blurSub;
						if (j+jmod < 0) { jmod = 0; }
						if (j+jmod > RESY-1) { jmod = 0; }
						putpixel(buffer, i+imod, j+jmod, makecol(r,g,b));
					}
					else putpixel(buffer, i, j, makecol(r,g,b));
				}
			}
		}
	}
}

void AntiAlias()
{
	clear(temp);
	int cval[9];
	int r[9];
	int g[9];
	int b[9];
	int inc = 1;
	if (antiAliasMode == 1) inc = 1;
	else if (antiAliasMode == 2) inc = 2; //circ extra mode
	else if (antiAliasMode == 3) inc = 3; //circ reference mode
	else if (antiAliasMode == 4) inc = 2; //disco mode
	else if (antiAliasMode == 5) inc = 5; //disco mode 2
	else if (antiAliasMode == 6) inc = 2; //water mode
	for (int i=0; i<RESX; i+=inc)
	{
	 	for (int j=0; j<RESY; j+=inc)
		 {
			int iminusone = i-1;
			if (iminusone == -1) iminusone = RESX-1;
			else if (iminusone == RESX) iminusone = 0;
			
			int iplusone = i+1;
			if (iplusone == -1) iplusone = RESX-1;
			else if (iplusone == RESX) iplusone = 0;
			
			int jminusone = j-1;
			if (jminusone == -1) jminusone = RESY-1;
			else if (jminusone == RESY) jminusone = 0;

			int jplusone = j+1;
			if (jplusone == -1) jplusone = RESY-1;
			else if (jplusone == RESY) jplusone = 0;

            cval[0] = getpixel(buffer, iminusone, jminusone);
			cval[1] = getpixel(buffer, i, jminusone);
            cval[2] = getpixel(buffer, iplusone, jminusone);
            cval[3] = getpixel(buffer, iminusone, j);
            cval[4] = getpixel(buffer, i, j);
            cval[5] = getpixel(buffer, iplusone, j);
            cval[6] = getpixel(buffer, iminusone, jplusone);
            cval[7] = getpixel(buffer, i, jplusone);
            cval[8] = getpixel(buffer, iplusone, jplusone);

			int rt = 0;
			int gt = 0;
			int bt = 0;

			for (int k=0; k<=8; k++)
			{
				r[k] = getr(cval[k]);
				rt+=r[k];
				g[k] = getg(cval[k]);
				gt+=g[k];
				b[k] = getb(cval[k]);
				bt+=b[k];
			}
			rt = rt/antiAliasGlow;
			gt = gt/antiAliasGlow;
			bt = bt/antiAliasGlow;
			if (rt > 255) rt = 255;
			if (gt > 255) gt = 255;
			if (bt > 255) bt = 255;
			if (rt < 0) rt = 0;
			if (gt < 0) gt = 0;
			if (bt < 0) bt = 0;
			
			if (filterInverse == 1)
			{
				rt = 255-rt;
				gt = 255-gt;
				bt = 255-bt;
			}
			
			if (antiAliasMode == 1 || antiAliasMode == 4) putpixel(temp, i, j, makecol(rt,gt,bt));
			else if (antiAliasMode == 2) circlefill(temp, i, j, 2, makecol(rt,gt,bt));
			else if (antiAliasMode == 3) circle(temp, i, j, 4, makecol(rt,gt,bt));
			else if (antiAliasMode == 5) circlefill(temp, i, j, 2, makecol(rt,gt,bt));
			else if (antiAliasMode == 6) circlefill(temp, i, j, rand()%2+2, makecol(rt,gt,bt));
		 }
	}
}

void AlterEntity(int Locator, int VOID, double X, double Y, double Xv, double Yv, double Xa, double Ya, int R, int G, int B)
{
	Entity[Locator].VOID = VOID;
	Entity[Locator].X = X;
	Entity[Locator].Y = Y;
	Entity[Locator].Xv = Xv;
	Entity[Locator].Yv = Yv;
	Entity[Locator].Xa = Xa;
	Entity[Locator].Ya = Ya;
	Entity[Locator].R = R;
	Entity[Locator].G = G;
	Entity[Locator].B = B;
	if (Entity[Locator].R > 255) Entity[Locator].R = 255;
	if (Entity[Locator].G > 255) Entity[Locator].G = 255;
	if (Entity[Locator].B > 255) Entity[Locator].B = 255;
	if (Entity[Locator].R < 1) Entity[Locator].R = 1;
	if (Entity[Locator].G < 1) Entity[Locator].G = 1;
	if (Entity[Locator].B < 1) Entity[Locator].B = 1;
}

void DrawEntity(int Locator)
{
	int x1 = (int)Entity[Locator].X;
	int y1 = (int)Entity[Locator].Y;
	int x2 = (int)(Entity[Locator].X + Entity[Locator].Xv);
	int y2 = (int)(Entity[Locator].Y + Entity[Locator].Yv);
	int col = makecol(Entity[Locator].R,Entity[Locator].G,Entity[Locator].B);
	
	if (entityType == 0)
	{
		for (int i=0; i<lineSize; i++)
		{
			if (i == 0) fastline(buffer, x1, y1, x2, y2, col);
			else
			{
				fastline(buffer, x1 + i, y1, x2 + i, y2, col);
			    fastline(buffer, x1, y1 + i, x2, y2 + i, col);
			}
		}
	}
	
	else if (entityType == 1)
	{
		circlefill(buffer, x1, y1, lineSize, col);
	}
	
	else if (entityType == 2)
	{
		for (int i=(lineSize*2); i>(lineSize); i--)
		{
			int tempR = (Entity[Locator].R*lineSize)/i;
			int tempG = (Entity[Locator].G*lineSize)/i;
			int tempB = (Entity[Locator].B*lineSize)/i;
			if (tempR > 255) tempR = 255;
			if (tempG > 255) tempG = 255;
			if (tempB > 255) tempB = 255;
			if (tempR < 0) tempR = 0;
			if (tempG < 0) tempG = 0;
			if (tempB < 0) tempB = 0;
			circlefill(buffer, x1, y1, i/2, makecol(tempR, tempG, tempB));
		}
	}
	
	else if (entityType == 3)
	{
		rect(buffer, x1-lineSize/2, y1-lineSize/2, x1+lineSize/2, y1+lineSize/2, col);
	}
	
	else if (entityType == 4)
	{
		rectfill(buffer, x1-lineSize/2, y1-lineSize/2, x1+lineSize/2, y1+lineSize/2, col);
	}
}


void init() {
	int depth, res;
	allegro_init();
	depth = desktop_color_depth();
	if (depth == 0) depth = 32;
	set_color_depth(depth);
	set_config_file("mblur.cfg");
	ARESX = get_config_int("Screen", "RESX", 800);
	ARESY = get_config_int("Screen", "RESY", 600);
	displayFPS = get_config_int("Screen", "displayFPS", 1);
	
	res = set_gfx_mode(GFX_AUTODETECT_WINDOWED, ARESX, ARESY, 0, 0);
	if (res != 0)
	{
		allegro_message(allegro_error);
		exit(-1);
	}
	install_timer();
	install_keyboard();
	install_mouse();
	enable_hardware_cursor();
	select_mouse_cursor(MOUSE_CURSOR_ARROW);
	srand((unsigned)time(NULL));
}
